// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from off_highway_general_purpose_radar_msgs:msg/Information.idl
// generated code does not contain a copyright notice

#ifndef OFF_HIGHWAY_GENERAL_PURPOSE_RADAR_MSGS__MSG__DETAIL__INFORMATION__TRAITS_HPP_
#define OFF_HIGHWAY_GENERAL_PURPOSE_RADAR_MSGS__MSG__DETAIL__INFORMATION__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "off_highway_general_purpose_radar_msgs/msg/detail/information__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"

namespace off_highway_general_purpose_radar_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const Information & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: sensor_type
  {
    out << "sensor_type: ";
    rosidl_generator_traits::value_to_yaml(msg.sensor_type, out);
    out << ", ";
  }

  // member: hw_temperature
  {
    out << "hw_temperature: ";
    rosidl_generator_traits::value_to_yaml(msg.hw_temperature, out);
    out << ", ";
  }

  // member: sensor_blind
  {
    out << "sensor_blind: ";
    rosidl_generator_traits::value_to_yaml(msg.sensor_blind, out);
    out << ", ";
  }

  // member: sw_fail
  {
    out << "sw_fail: ";
    rosidl_generator_traits::value_to_yaml(msg.sw_fail, out);
    out << ", ";
  }

  // member: hw_fail
  {
    out << "hw_fail: ";
    rosidl_generator_traits::value_to_yaml(msg.hw_fail, out);
    out << ", ";
  }

  // member: can_fail
  {
    out << "can_fail: ";
    rosidl_generator_traits::value_to_yaml(msg.can_fail, out);
    out << ", ";
  }

  // member: config_fail
  {
    out << "config_fail: ";
    rosidl_generator_traits::value_to_yaml(msg.config_fail, out);
    out << ", ";
  }

  // member: diag_mode
  {
    out << "diag_mode: ";
    rosidl_generator_traits::value_to_yaml(msg.diag_mode, out);
    out << ", ";
  }

  // member: dtc
  {
    out << "dtc: ";
    rosidl_generator_traits::value_to_yaml(msg.dtc, out);
    out << ", ";
  }

  // member: dtc_order_id
  {
    out << "dtc_order_id: ";
    rosidl_generator_traits::value_to_yaml(msg.dtc_order_id, out);
    out << ", ";
  }

  // member: sensor_not_safe
  {
    out << "sensor_not_safe: ";
    rosidl_generator_traits::value_to_yaml(msg.sensor_not_safe, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Information & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: sensor_type
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "sensor_type: ";
    rosidl_generator_traits::value_to_yaml(msg.sensor_type, out);
    out << "\n";
  }

  // member: hw_temperature
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "hw_temperature: ";
    rosidl_generator_traits::value_to_yaml(msg.hw_temperature, out);
    out << "\n";
  }

  // member: sensor_blind
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "sensor_blind: ";
    rosidl_generator_traits::value_to_yaml(msg.sensor_blind, out);
    out << "\n";
  }

  // member: sw_fail
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "sw_fail: ";
    rosidl_generator_traits::value_to_yaml(msg.sw_fail, out);
    out << "\n";
  }

  // member: hw_fail
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "hw_fail: ";
    rosidl_generator_traits::value_to_yaml(msg.hw_fail, out);
    out << "\n";
  }

  // member: can_fail
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "can_fail: ";
    rosidl_generator_traits::value_to_yaml(msg.can_fail, out);
    out << "\n";
  }

  // member: config_fail
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "config_fail: ";
    rosidl_generator_traits::value_to_yaml(msg.config_fail, out);
    out << "\n";
  }

  // member: diag_mode
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "diag_mode: ";
    rosidl_generator_traits::value_to_yaml(msg.diag_mode, out);
    out << "\n";
  }

  // member: dtc
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "dtc: ";
    rosidl_generator_traits::value_to_yaml(msg.dtc, out);
    out << "\n";
  }

  // member: dtc_order_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "dtc_order_id: ";
    rosidl_generator_traits::value_to_yaml(msg.dtc_order_id, out);
    out << "\n";
  }

  // member: sensor_not_safe
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "sensor_not_safe: ";
    rosidl_generator_traits::value_to_yaml(msg.sensor_not_safe, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Information & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace off_highway_general_purpose_radar_msgs

namespace rosidl_generator_traits
{

[[deprecated("use off_highway_general_purpose_radar_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const off_highway_general_purpose_radar_msgs::msg::Information & msg,
  std::ostream & out, size_t indentation = 0)
{
  off_highway_general_purpose_radar_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use off_highway_general_purpose_radar_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const off_highway_general_purpose_radar_msgs::msg::Information & msg)
{
  return off_highway_general_purpose_radar_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<off_highway_general_purpose_radar_msgs::msg::Information>()
{
  return "off_highway_general_purpose_radar_msgs::msg::Information";
}

template<>
inline const char * name<off_highway_general_purpose_radar_msgs::msg::Information>()
{
  return "off_highway_general_purpose_radar_msgs/msg/Information";
}

template<>
struct has_fixed_size<off_highway_general_purpose_radar_msgs::msg::Information>
  : std::integral_constant<bool, has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<off_highway_general_purpose_radar_msgs::msg::Information>
  : std::integral_constant<bool, has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<off_highway_general_purpose_radar_msgs::msg::Information>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // OFF_HIGHWAY_GENERAL_PURPOSE_RADAR_MSGS__MSG__DETAIL__INFORMATION__TRAITS_HPP_
